   1 REM Adventure Gamebook
         Express Solver
part 2 - reverse links setup
         ? 2010 Jim Grimwood
   2 DEF FN d$(l$,n)=l$+CHR$ 14+CHR$ 0+CHR$ 0+CHR$ FN g(n)+CHR$ FN h(n)+CHR$ 0+",":
     DEF FN h$(s)=CHR$ FN g(s)+CHR$ FN h(s):
     DEF FN t(c)=FN s(t$(c TO c+k1)): DEF FN u(c)=FN s(u$(c TO c+k1))
   3 DEF FN i$(s,l)=CHR$ FN g(s)+CHR$ FN h(s)+CHR$ l:
     DEF FN s(v$)=CODE v$(k1)+256*CODE v$(k2):
     DEF FN p$(p)="000"(  TO k3-LEN STR$ p)+STR$ p+"<"
   4 DEF FN p(a)=PEEK a+256*PEEK (a+1):DEF FN g(v)=v-FN h(v)*256:
     DEF FN h(v)=INT (v/256): DEF FN r(v$)=256*CODE v$(k1)+CODE v$(k2)
   5 CLEAR VAL "65535-167-1": LET emax=0:LET  bmax=emax:GO SUB 9130:LET errsp=k0
   6 LET bc=USR mcpos: POKE 23670,k0
  10 DIM t$(48): REM.............
     FORWARD LINKS HEADER.......
     t$(32)=book title..........
     t$( 8)=file base name (f$).
     t$( 2)=exits length (elen).
     t$( 2)=total entries(enum).
     t$( 2)=maximum  "   (emax).
     t$( 2)=conds length (clen)
  11 DIM u$(48): REM u$() BWARD LINKS HEADER
  12 LET p$="-u--lspq":GO SUB 9150:LET elen=k0: LET clen=k0:LET blen=k0:
     LET enum=k0:LET bnum=k0:LET stream=k0:DIM b$(32):DIM f$(k8):
     LET h$=CHR$ k8+CHR$ k8: LET lrow=20:DIM n(lrow):DIM o(lrow):
     IF PEEK 23670 THEN
       GO SUB 1514+PEEK 23670
 100 GO SUB 900
 102 INPUT "Update/Load/Save/Print/Quit ";q$:LET pnum=k0:FOR p=k1
       TO LEN p$:LET pnum=pnum+(p AND q$=p$(p)):NEXT p
 103 IF q$="u" AND  NOT emax  THEN
       GO TO 1520
 104 IF q$="u" AND  NOT enum  OR q$="s" AND  NOT bnum  THEN
       LET e$="NO DATA":GO SUB 1900:GO TO 102
 106 PRINT AT k1,k0;t$(TO 32):GO SUB 915
 110 PRINT BRIGHT k1;q$;"--":GO SUB 1000+pnum*100:GO TO 100
 900 REM *** PRINT STATUS BAR
 901 LET free=mcwork-b1-elen-blen:LET pline=24-PEEK 23689:LET
     pline=pline+ NOT pline
 902 PRINT AT k0,k0;"Loc";INVERSE k1;enum;INVERSE k0;"Max";
     INVERSE k1;emax;INVERSE k0;"Siz";INVERSE k1;elen+blen;
     INVERSE k0;"Spc";INVERSE k1;free-(free AND free<k0);
     INVERSE k0;TAB 26;"AGES-2"
 909 GO SUB 915:RETURN
 915 IF pline<22  THEN
       PRINT AT pline,k0;
 916 IF pline>=22  THEN
       PRINT AT 21,k0
 919 RETURN
1000 REM *** INVALID OPTION
1010 LET e$=p$:GO SUB 1950:RETURN
1100 REM *** NO ACTION
1101 RETURN
1200 REM *** UPDATE
1205 IF blen  THEN
       LET e$="UPDATE ALREADY DONE":GO SUB 1900:RETURN
1206 IF enum<>emax THEN
       LET e$="ENTRIES <"+STR$ enum+"> REQUIRED <"+STR$ emax+">"
       :GO SUB 1900:RETURN
1210 PRINT #0; INVERSE k1;AT k0,k0;"INITIALISING REVERSE ARRAY":
     PRINT USR mcstack,edat,b1,irow,"y$()",mcinity;: LET blen=bmax*k3: LET bnum=bmax
1211 POKE b1+k1,k0:REM        LOCATION #1 HAS NO BACK-LINKS
1220 GO SUB 2020:RETURN
1300 REM *** NO ACTION
1301 RETURN
1400 REM *** NO ACTION
1401 RETURN

1500 REM *** LOAD DATA
1501 INPUT "Forward or Reverse [fb] ";d$:IF d$<>"f" AND d$<>"r" THEN
       LET e$="fr":GO SUB 1950:RETURN
1502 IF d$="r" THEN
       GO TO 1553
1503 IF elen  THEN
       INPUT "Overwrite Current Data?[yn]";o$:IF o$<>"y" AND o$ <>"n" THEN
         LET e$="yn":GO SUB 1950:GO TO 1503
1504 IF elen  THEN
       IF o$="n" THEN
         RETURN
1510 GO SUB 2000:PRINT INVERSE k1;"LOAD ";f$;"t":LOAD f$+"t"DATA t$():
     LET emax=FN t(45): PRINT USR mcstack,"t$()",mcputt;:
     POKE 23670,k1:GO TO 1526
1516 PRINT USR mcstack,"t$()",mcgett;:LET f$=t$(33 TO 40):LET elen=FN t(41):
     LET enum=FN t(43):LET emax=FN t(45): LET clen=FN t(47): POKE 23670,k0
1517 LET u$=t$: LET blen=k0:LET u$(41 TO 42)=FN h$(blen):LET bnum=k0:
     LET u$(43 TO 44)=FN h$(bnum):LET bmax=emax
1518 PRINT INVERSE k1;"LOAD ";f$;"i": LOAD f$+"i" DATA i$():
     PRINT INVERSE k1;"LOAD ";f$;"c": LOAD f$+"c" DATA a$():
     PRINT INVERSE k1;"LOAD ";f$;"d": LOAD f$+"d" CODE b1+edat-cdat,cdat+edat:
     CLS:PRINT AT k1,k0;t$(TO 32):RETURN

1520 REM *** ASSIGN SPACE
1525 INPUT "Number of Locations (2-";(irow);") ";emax:LET emax=INT emax
     :IF emax<k2  OR emax>irow  THEN
       LET e$="2-"+STR$ irow:GO SUB 1950:GO TO 1525
1526 POKE 23675,FN g(emax):POKE 23676,FN h(emax):BORDER k0:INK 5
     :PAPER k0:GO SUB 9123:CLEAR 65535-167-edat*k2-k1: GO SUB 9130:
     LET emax=FN p(23675):LET bmax=emax
1530 GO TO 1580

1553 IF blen  THEN
       INPUT "Overwrite Current Data?[yn]";o$:IF o$<>"y" AND o$<>"n" THEN
         LET e$="yn":GO SUB 1950:GO TO 1553
1554 IF blen  THEN
       IF o$="n" THEN
         RETURN
1560 GO SUB 2000:PRINT INVERSE k1;"LOAD ";f$;"tu":LOAD f$+"tu"DATA u$():
     LET bmax=FN u(45):PRINT USR mcstack,"u$()",mcputt;:POKE 23670,51:
     GO TO 1576
1566 PRINT USR mcstack,"u$()",mcgett;:LET f$=u$(33 TO 40):LET blen=FN u(41):
     LET bnum=FN u(43):LET bmax=FN u(45):POKE 23670,k0
1568 PRINT INVERSE k1;"LOAD ";f$;"iy":LOAD f$+"iy"DATA y$():
     PRINT INVERSE k1;"LOAD ";f$;"db":LOAD f$+"db"CODE b1,blen
1570 PRINT INVERSE k1;"LOAD ";f$;"t":LOAD f$+"t"DATA t$():LET elen=FN t(41):
     LET enum=FN t(43):LET emax=FN t(45): LET clen=FN t(47):
     PRINT INVERSE k1;"LOAD ";f$;"c3": LOAD f$+"c3" DATA c$():
     CLS:PRINT AT k1,k0;u$(TO 32):RETURN

1576 POKE 23675,FN g(bmax):POKE 23676,FN h(bmax):BORDER k0:INK 5
     :PAPER k0:GO SUB 9123:CLEAR 65535-167-edat*k2-k1: GO SUB 9130:
     LET bmax=FN p(23675):LET emax=bmax
1580 GO SUB 9130:GO SUB 9100
1587 DIM i$(irow,6):REM        links index- entry start 2 bytes
                      length 1 byte
1588 DIM y$(irow,k3): DIM a$(crow,28): REM long version of c$
     DIM c$(crow,9)
1589 GO TO 10
1600 REM *** SAVE DATA
1605 PRINT #k0;INVERSE k1;AT k0,k0;"CHECKING FOR BROKEN LINKS"
1606 PRINT USR mcstack,"y$()",bmax,mccheckl;
1607 INPUT "": PRINT #k0;INVERSE k1;AT k0,k0;"COMPRESSING c$()":
     FOR i=k1 TO crow:
       PRINT #k0;AT k0,20;i: LET c$(i)=a$(i,k1 TO 6)+a$(i,26 TO 28):
     NEXT i: INPUT ""
1610 LET d$="r":GO SUB 2000:PRINT "SAVE ";f$;"tu";h$;
     :LET u$(33 TO)=f$+FN h$(blen)+FN h$(bnum)+FN h$(bmax)+FN h$(clen)
1620 SAVE f$+"tu"DATA u$():
     PRINT "iy";h$;:SAVE f$+"iy"DATA y$():
     PRINT "db";h$;:SAVE f$+"db"CODE b1,blen:
     PRINT "t ";h$;: SAVE f$+"t"DATA t$():
     PRINT "c3": SAVE f$+"c3"DATA c$():
     RETURN
1700 REM *** PRINT DATA
1702 IF  NOT blen  THEN
       LET e$="NO DATA":GO SUB 1900:RETURN
1710 IF  NOT stream  THEN
       INPUT "Screen or Printer? [sp] ";o$:LET stream=(k2  AND o$
       ="s")+(k3  AND o$="p"):IF  NOT stream  THEN
         LET e$="sp":GO SUB 1950:GO TO 1710
1715 LET e$="1-"+STR$ bnum:INPUT "Range? ("+e$+")"'"From:";ea;" To:";ez:
     LET ea=INT ea:LET ez=INT ez:IF ea<k1  OR ez>bnum
      OR ea>ez  THEN
       GO SUB 1950:GO TO 1715
1719 PRINT #stream; u$(TO 32);TAB k0
1720 FOR i=ea  TO ez:
       LET start=FN s(y$(i)): LET length=CODE y$(i,k3):
       PRINT #stream;FN p$(i);: LET col=k0
1721   IF stream=k3 THEN
         PRINT #0;AT k0,k0;i
1730   FOR e=start  TO start+length-k3  STEP k3:
         LET col=(col  AND col<28)+4: LET loc=FN p(e)
1740     PRINT #stream;TAB col;" ";loc;:
       NEXT e: PRINT #stream
1790 NEXT i: RETURN
1800 REM *** QUIT
1814 GO SUB 9123
1815 STOP
1900 REM *** ERROR MESSAGE
1910 PRINT #0;AT k0,k0; INK k2; FLASH k1;e$;TAB 30;INVERSE k1;"=>":
     PAUSE k0:PRINT #0;AT k0,k0;b$:RETURN
1950 LET e$="OPTIONS ARE: "+e$:GO TO 1910
2000 REM *** INDEX FILE NAME
2006 IF q$="l" OR d$="f" AND t$(33 TO 40)=b$(TO k8) OR d$="r" AND u$(33 TO 40)=b$(TO k8)
      THEN
       LET e$="1-8 chars":INPUT "Index Name ("+e$+") ";LINE f$:
       IF LEN f$<k1  OR LEN f$>k8  THEN
         GO SUB 1950:GO TO 2006
2007 RETURN
2020 REM *** DATA GENERATION
ADD LOCATION (a) AS AN ENTRY
 TO EACH EXIT LOCATION (n)
2021 REM *** UPDATE THE INDEX
           & DATA BLOCK
2022 PRINT #0; INVERSE k1;AT k0,k0;"BUILDING REVERSE ARRAY"; TAB k0;
2023 PRINT USR mcstack,emax,blen,b1,elen,"y$()","i$()",enum,mcupdt3;:
     LET blen=FN p(23675): LET free=FN p(23677)
2026 IF  NOT free THEN
       LET e$="NO ROOM":GO SUB 1900

2540 RETURN

9000 REM *** ERROR TRAP
9005 LET err=PEEK 23560+k1:LET err=err-(12 AND err=33):LET erl=
     FN p(23615):LET r$=CHR$ (err+48+(7 AND err>9))+" ":LET e=e
     (err+k1)
9006 LET erc=PEEK e:LET r$=r$+CHR$ (erc-(128 AND erc>=128)):IF
     erc<128 THEN
       LET e=e+k1:GO TO 9006
9010 INPUT INK k2;(erl);":";(r$)'"Retry/Menu/Quit? [rmq] ";o$:IF
     o$<>"r" AND o$<>"m" AND o$<>"q" THEN
       LET e$="rmq":GO SUB 1950:GO TO 9010
9015 GO SUB 9112
9020 IF o$="r" THEN GO TO erl
9021 IF o$="q" THEN GO TO 1800
9022 IF o$="m" THEN GO TO 100
9029 RETURN
9100 REM *** SET UP ERROR TRAP
9110 RESTORE 9191
9111 DIM e(28):FOR i=k1  TO 28:READ e(i):NEXT i
9112 LET errsp=23613:LET errgoto=FN p(FN p(errsp)):LET sp=FN p(e
     rrsp):POKE sp,FN g(mctrap):POKE sp+k1,FN h(mctrap)
9120 RETURN
9123 REM *** REMOVE ERROR TRAP
9124 IF errsp  THEN
       LET sp=FN p(errsp):POKE sp,FN g(errgoto):POKE sp+k1,FN h(e
       rrgoto)
9125 RETURN
9129 REM *** SET UP MACHINE CODE
9130 GO SUB 9150:LET mcpos=FN p(23627)-mclen:LET b1=FN p(23730)+k1:
     LET b2=b1+edat: LET mcstack=mcpos+216:LET mcputt=mcstack+53:
     LET mcgett=mcputt+6: LET mcmove=mcgett+45:LET mctrap=mcmove+34+115+37+69:
     LET mcwork=65535-167
9131 LET mcupdt2=mctrap+55:LET mcinity=mcupdt2+66:
     LET mcupdt3=mcinity+68: LET mccheckl=mcupdt3+476
9149 RETURN
9150 LET mclen=1427: LET k0=0: LET k1=1: LET k2=2: LET k3=k3: LET k8=8:
     LET irow=500: LET edat=irow*9: LET nrow=INT (irow/5): LET crow=300: LET cdat=irow*k3: RETURN

9160 REM INSTALL MACHINE CODE...    with GO TO 9161
     REM Shift down VARS to reclaim old CODE space
9161 CLEAR : GOSUB 9164: INPUT "Old ";o: LET ov=FN p(va)-o-(o>0):
     LET s$=FN d$("A",va)+FN d$("B",FN g(ov))+FN d$("C",FN h(ov))+FN d$("D",ov)+FN d$("E",128):
     GO SUB 9165: POKE a,b: POKE a+1,c: POKE d,e
     REM Shift up VARS to assign new CODE space
9162 CLEAR : GOSUB 9164: INPUT "New ";n: DIM a$(n-32): LET nv=FN p(va)+n+1:
     LET s$=FN d$("A",va)+FN d$("B",FN g(nv))+FN d$("C",FN h(nv))
     GO SUB 9165: POKE a,b: POKE a+1,c
9163 GOSUB 9164: GO SUB 9150: LET mcpos=FN p(va)-mclen:
     LOAD "AGES-2code"CODE mcpos,mclen:
     PRINT "machine code starts at ";mcpos'"NOT " AND PEEK (mcpos-k2)<>VAL "13";"OK": STOP
9164 LET df=16384: LET da=23563: LET va=23627: POKE da,0: POKE da+1,0: RETURN
9165 LET s$(LEN s$)=")":
     FOR s=0 TO LEN s$-1: POKE df+s,CODE s$(s+1): NEXT s:
     POKE da,FN g(df): POKE da+1,FN h(df): RETURN

9190 REM ERROR MESSAGE ADDRESSES
9191 DATA 5010,5012,5028,5046,5061,5074,5087,5101,5121,5132,5146,
     5162,5182,5199,5219,5230,5247,5263,5276,5292,5310,5324,5342,
     5356,5370,5384,5398,5413

9200 LET s=VAL "FN p(23627)-26": LET p=FN p(s):
     FOR a=s TO VAL "FN p(23627)-2" STEP VAL "2":
       LET d=FN p(a): PRINT d,"+";d-p: LET p=d:
     NEXT a: LIST VAL "9130": STOP
9999 REM *** MACHINE CODE STARTS
             AFTER THIS LINE